<!--
 * @Author: 小明丶
 * @Date: 2020-05-08 19:04:22
 * @LastEditors: 小明丶
 * @LastEditTime: 2020-06-24 11:27:18
 * @Description: 登录也输入框组件
 -->
<template>
  <div class="h-ipt-box">
    <div class="ipt-div">
      <i class="left iconfont" :class="icon" v-if="icon"></i>
      <input
        :type="type"
        class="ipt"
        v-model="newValue"
        :maxlength="maxlength"
        :placeholder="placeholder"
        @focus="showClose"
        @blur="noClose"
      />
      <div class="right-slot">
        <slot name="right">
        </slot>
      </div>
      
      <i class="right iconfont iconreeor-fill" v-if="close && newValue && getClose" @click="deleteMsg"></i>
    </div>
  </div>
</template>
<script>
export default {
  name:'h-ipt',
  model: {
    prop: "value",
    event: "input"
  },
  props: {
    getClose:{
      type:Boolean,
      default:false
    },
    icon: {
      type: String
    },
    maxlength: {
      type: Number
    },
    placeholder: {
      type: String,
      default: "请输入"
    },
    value: {
      type: [String, Number]
    },
    type: {
      type: String,
      default: "text"
    },
    
  },
  data() {
    return {
        close:false,
    };
  },
  computed: {
    newValue: {
      get: function() {
        return this.value;
      },
      set: function(value) {
        this.$emit("input", value);
      }
    }
  },
  methods:{ 
      showClose(){
          this.close = true
      },
      noClose(){
          this.close = false
      },
      deleteMsg(){
        this.newValue = ''
      }
  }
};
</script>
<style lang="less" scoped>
.h-ipt-box {
  width: 100%;
  text-align: center;
  .ipt-div {
    display: inline-block;
    width: 80%;
    height: 40px;
    border-radius: 20px;
    border: 1px solid rgb(234, 234, 234);
    //line-height: 40px;
    position: relative;
    .left {
      font-size: 24px;
      color: @c-default;
      position: absolute;
      left: 10px;
      top: 6px;
    }
    .right{
        font-size: 18px;
        color: @c-default;
        position: absolute;
        right: 10px;
        top: 10px;
    }
    .ipt {
      position: absolute;
      right: 100px;
      top: 10px;
      width: 50%;
      border: 0; // 去除未选中状态边框
      outline: none; // 去除选中状态边框
      background-color: rgba(0, 0, 0, 0); // 透明背景
    }
    .right-slot{
      position: absolute;
      right: 10px;
      top: 6px;
    }
  }

  input::-webkit-input-placeholder {
    color: rgb(163, 163, 163);
  }

  input::-moz-placeholder {
    /* Mozilla Firefox 19+ */
    color: rgb(163, 163, 163);
  }

  input:-moz-placeholder {
    /* Mozilla Firefox 4 to 18 */
    color: rgb(163, 163, 163);
  }

  input:-ms-input-placeholder {
    /* Internet Explorer 10-11 */
    color: rgb(163, 163, 163);
  }
  input:-internal-autofill-previewed,
  input:-internal-autofill-selected {
    -webkit-text-fill-color: #333;
    transition: background-color 5000s ease-out 0.5s;
  }
}
</style>